#ifndef _EXCHANGE_H
#define _EXCHANGE_H

namespace RS485 {
    void initExchange( void );
    int  askByte( int, int, char* );
    int  askWord( int, int, short* );
    int  askLong( int, int, int* );
    int  askData( int, int, unsigned char* );
    int  sendSimpleCommand( int, int );
    int  sendByteCommand( int, int, char );
    int  sendWordCommand( int, int, short );
    int  sendData( int, int, unsigned char* );
    int  sendVoid( unsigned char*, int, unsigned char* );
    int  deviceBusy( void );
    int  readData( unsigned char*, unsigned char* );
    int  readData( int*, int*, unsigned short* );
    void resetData( void );
    void setBaudeRate( int );
}

namespace Error {
    struct  Exchange {
        const char* from;
        const char* what;
        const char* why;
        Exchange( const char* ch, const char* mn, const char* cs = 0 ){
            from = ch;
            what = mn;
            why =  cs;
        }
    };
}

#ifdef  _EXCHANGE

#define low(i)      (unsigned char)((i)&0x00ff)
#define high(i)     (unsigned char)(((i)&0xff00)>>8)

#define MAXRETRY    3
#define IO_BUFF_SIZE	64
#define MAX_PACKET_SIZE 32
#define DEV_FILE_OUT   "/dev/mcua0"

#define ACK  SignalACK
#define NAK  SignalNAK
#define NOD  SignalNOD
#define ACN  SignalACN
#define ACY  SignalACY
#define ACW  SignalACW
#define SINC SignalSINC
#define DNG  SignalDNG
#define PKL  SignalPKL
#define PBO  SignalPBO
#define DSC  SignalDSC
#define COL  SignalCOL
#define EER  SignalEER
#define UND  SignalUND

enum { INFO_SIG, LOOP_SIG, CHECK_SIG, ABORT_SIG };

typedef struct Sig {
    int   code;
    int   stype;
    char* abbr;
    char* text;
};

#endif
#endif
