#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio_ext.h>
#include <string.h>
#include <errno.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include "exchange.h"
#include "astrotime.h"
#include "version.h"

char	string[128];
unsigned char buff[32];
unsigned char outstr[64];
const char *vers = VERSION_TEXT;
FILE	*inpfile;
unsigned short ipause = 20;
int ibaude_rate = -1;
AstroDateTime utc;

int main( int ac, char **av){
    int nbytes = 0;
    int dbytes = 0;
    int ii;
    fprintf( stdout, "\n                lmox tool Ver.%s\n", vers );
    opterr = 0;
    while( (ii = getopt(ac, av, ":p:r:h")) != -1 ) {
        switch (ii) {
            case 'h':   fprintf( stdout, "Usage: avrup -options [file]\n");
                        exit(1);
            case 'p':   if(optarg!=NULL) sscanf( optarg, "%d", &ipause );
                        break;
            case 'r':   if(optarg!=NULL) sscanf( optarg, "%d", &ibaude_rate );
                        break;
            case '?':   fprintf( stdout, "Option -%c is not legal..\n", optopt );
                        exit(1);
            case ':':   fprintf( stdout, "Option -%c has missing argument..\n", optopt );
            default:    exit(1);
        }
    }
    if( av[optind] == NULL ) {
	inpfile = stdin;
//        fprintf( stdout, "Usage: avrup -options file.hex\n");
//        exit(1);
    } else {
	  inpfile = fopen( av[optind], "r" );
    }

    try{
        RS485::initExchange();
        if( ibaude_rate > 0 ) RS485::setBaudeRate( ibaude_rate );
        while(1){
            printf("<");
            if( fgets( string, 128, inpfile ) == 0 ) break;
            if( strlen( string ) < 2 ) break;
            if( string[0] == '#' ) continue;
            if( inpfile != stdin ) fprintf( stdout, "%s", string );
            int np = sscanf( string, "%hhx %hhx %hhx %hhx %hhx %hhx %hhx %hhx %hhx %hhx",
                buff,buff+1,buff+2,buff+3,buff+4,buff+5,buff+6,buff+7,buff+8,buff+9 );
            if( np == 0 ) break;
            nbytes = RS485::sendVoid( buff, np, outstr );

            if( nbytes ) {
                printf("Data %d bytes: ", nbytes );
                for( int i=0; i< nbytes; i++ ) printf("%02x ", outstr[i] );
                printf("\n");
            } else  printf("Signal %s\n", outstr );
            usleep(ipause*1000);
//	    int l = 0;
//	    if( buff[1] == 0x80 ) {
//            for( int j = 0; j<10000; j++ ) {
//                if( dbytes = RS485::readData( outstr ) ) {
//                    printf("%3d %3d ", l++, dbytes );
//                    for( int i=0; i< dbytes; i++ ) printf("%02x ", outstr[i] );
//                    printf("\n");
//                }
//            }
//	    }
        }
    }
    catch( Error::Exchange err ){
        fprintf( stdout, "%s: %s\n", err.from, err.what );
        exit(FAIL);
    }
    exit(0);
}
